DOCKER_BUILD_ARGS=
include config.mk
ifdef DOCKER_BASE_IMAGE_TAG
include includes/$(DOCKER_BASE_IMAGE_TAG).mk
include includes/$(OS_NAME).mk
include includes/$(OS_NAME).$(OS_RELEASE).mk
endif
DOCKER_REPOSITORY_PATH=$(DOCKER_REPOSITORY_BASEPATH)/$(DOCKER_IMAGE_NAME)
ifdef DOCKER_BASE_IMAGE_TAG
ifndef BASE_IMAGE_TAG
BASE_IMAGE_TAG=$(DOCKER_BASE_IMAGE_TAG)
endif
ifndef DOCKER_TAG
DOCKER_TAG=$(DOCKER_BASE_IMAGE_TAG)
endif
endif
ifdef DOCKER_TAG
DOCKER_QUALNAME=$(DOCKER_REPOSITORY_PATH):$(DOCKER_TAG)
endif
DOCKER_PUSH_RULES := $(addprefix docker-push-, $(BASE_IMAGE_VERSIONS))
DOCKER_BUILD_RULES := $(addprefix docker-build-, $(BASE_IMAGE_VERSIONS))
ifndef DOCKER_CONTEXT
DOCKER_CONTEXT=.
endif
DOCKER_BUILD=docker build -t $(DOCKER_REPOSITORY_PATH):$(DOCKER_TAG)
DOCKER_BUILD += $(DOCKER_CONTEXT)
DOCKER_BUILD += --build-arg "BASE_IMAGE_REPOSITORY=$(BASE_IMAGE_REPOSITORY)"
DOCKER_BUILD += --build-arg "BASE_IMAGE_TAG=$(BASE_IMAGE_TAG)"
DOCKER_BUILD += --build-arg "OS_PKG_UPDATE=$(OS_PKG_UPDATE)"
DOCKER_BUILD += --build-arg "OS_PKG_INSTALL=$(OS_PKG_INSTALL)"
DOCKER_BUILD += --build-arg "OS_PKG_PURGE=$(OS_PKG_PURGE)"
DOCKER_BUILD += --build-arg "OS_USER=$(OS_USER)"
DOCKER_BUILD += --build-arg "OS_GROUP=$(OS_GROUP)"
DOCKER_BUILD += --build-arg "OS_CLEANUP=$(OS_CLEANUP)"
DOCKER_BUILD += $(DOCKER_BUILD_ARGS)
include includes/build.mk


docker-build:
	@make $(DOCKER_BUILD_RULES)


docker-push:
	@make $(DOCKER_PUSH_RULES)


docker-build-%:
	@make _docker-build DOCKER_BASE_IMAGE_TAG=$(*)

docker-push-%:
	@make _docker-build DOCKER_BASE_IMAGE_TAG=$(*)
	@make _docker-push DOCKER_BASE_IMAGE_TAG=$(*)


_docker-push:
	@docker tag $(DOCKER_QUALNAME) $(DOCKER_REGISTRY)/$(DOCKER_QUALNAME)
	@docker push $(DOCKER_REGISTRY)/$(DOCKER_QUALNAME)


pki/server:
	@mkdir -p ${CURDIR}/pki/server
	@openssl req -new -newkey rsa:4096 -days 3650 -nodes -x509\
		-keyout ${CURDIR}/pki/server/tls.key\
		-out ${CURDIR}/pki/server/tls.crt\
		-subj "/CN=localhost$(X509_SUBJECT)"
	@git add ${CURDIR}/pki/server/*
	@git commit -m "Generated snakeoil X.509 certificate for local development"
